package com.ejie.ab79.control;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.SessionAttributes;

import com.ejie.ab79.clientesWS.ab61WebService.Ab61Exception;
import com.ejie.ab79.clientesWS.ab61WebService.DocumentoExpediente;
import com.ejie.ab79.clientesWS.ab61WebService.DocumentoWS;
import com.ejie.ab79.clientesWS.ab61WebService.Usuario;
import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.DocumentosSubidos;
import com.ejie.ab79.model.actuaciones.Actuaciones;
import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.ab79.model.plantillas.ParametrosConfig;
import com.ejie.ab79.service.DocumentosSubidosService;
import com.ejie.ab79.service.actuaciones.ActuacionesService;
import com.ejie.ab79.service.plantillas.ParametrosConfigService;
import com.ejie.ab79.webservice.adaptadores.ab61WebServiceAdaptador;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ActuacionesController  
 * 
 *  
 */
@SessionAttributes("usuario")
@Controller
@RequestMapping(value = "/actuaciones")

public class ActuacionesController {

	private static final Logger logger = LoggerFactory.getLogger(ActuacionesController.class);

	@Autowired
	private ActuacionesService actuacionesService;

	@Autowired
	private ParametrosConfigService parametrosConfigService;

	@Autowired
	private ab61WebServiceAdaptador ab61WebServiceAdaptador;

	@Autowired
	private DocumentosSubidosService documentosSubidosService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idActuacion
	 *            Integer
	 * @return Actuaciones Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idActuacion}", method = RequestMethod.GET)
	public @ResponseBody Actuaciones get(@PathVariable Integer idActuacion) {
		Actuaciones actuaciones = new Actuaciones();
		actuaciones.setIdActuacion(idActuacion);
		actuaciones = this.actuacionesService.find(actuaciones);
		ActuacionesController.logger.info("[GET - findBy_PK] : Obtener Actuaciones por PK");
		return actuaciones;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterActuaciones
	 *            Actuaciones Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Actuaciones> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Actuaciones> getAll(@ModelAttribute Actuaciones filterActuaciones) {
		ActuacionesController.logger.info("[GET - find_ALL] : Obtener Actuaciones por filtro");
		return this.actuacionesService.findAll(filterActuaciones, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param actuaciones
	 *            Actuaciones Bean que contiene la informacion a modificar.
	 * @return Actuaciones Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Actuaciones edit(Model model, @RequestBody Actuaciones actuaciones,
			@ModelAttribute(value = "usuario") Usuario usuario) {

		actuaciones.setUsuarioUltmodificacion(usuario.getUsuario());
		Actuaciones actuacionesAux = this.actuacionesService.update(actuaciones);
		ActuacionesController.logger.info("[PUT] : Actuaciones actualizado correctamente");
		return actuacionesAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param actuaciones
	 *            Actuaciones Bean que contiene la informacion con la que se va
	 *            a crear el nuevo registro.
	 * @return Actuaciones Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Actuaciones add(Model model, @RequestBody Actuaciones actuaciones,
			@ModelAttribute("usuario") Usuario usuario) {
		ActuacionesController.logger.info("[POST] : Actuaciones insertado correctamente");
		actuaciones.setUsuarioRegistro(usuario.getUsuario());
		Actuaciones actuacionesAux = this.actuacionesService.add(actuaciones);
		ActuacionesController.logger.info("[POST] : Actuaciones insertado correctamente");
		return actuacionesAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idActuacion
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return Actuaciones Bean eliminado.
	 */
	@RequestMapping(value = "/{idActuacion}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Actuaciones remove(@PathVariable Integer idActuacion) {
		Actuaciones actuaciones = new Actuaciones();
		actuaciones.setIdActuacion(idActuacion);
		this.actuacionesService.remove(actuaciones);
		ActuacionesController.logger.info("[DELETE] : Actuaciones borrado correctamente");
		return actuaciones;
	}

	@RequestMapping(value = "/eliminarConDocumentos/{idActuacion}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Actuaciones eliminarConDocumentos(@PathVariable Integer idActuacion) {
		Actuaciones actuaciones = new Actuaciones();
		actuaciones.setIdActuacion(idActuacion);
		this.actuacionesService.eliminarActuacion(actuaciones);
		ActuacionesController.logger.info("[DELETE] : Actuaciones borrado correctamente");
		return actuaciones;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {

		ActuacionesController.logger.info("[GET - View] : actuaciones");
		ParametrosConfig parametrosConfigMovilidad = new ParametrosConfig();
		parametrosConfigMovilidad.setDescripcion(Constantes.CONFIGURACION_MOVILIDAD);
		parametrosConfigMovilidad = this.parametrosConfigService.find(parametrosConfigMovilidad);

		if (parametrosConfigMovilidad != null) {
			model.addAttribute("parametroMovilidad", parametrosConfigMovilidad.getValor());
		}
		return "actuaciones";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterActuaciones
	 *            Actuaciones Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<Actuaciones> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Actuaciones> filter(
			@RequestJsonBody(param = "filter") Actuaciones filterActuaciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ActuacionesController.logger.info("[POST - filter] : Obtener Actuacioness");
		return this.actuacionesService.filter(filterActuaciones, tableRequestDto, false);
	}

	@RequestMapping(value = "/countActuacionesInspeccion/{idInspeccion}", method = RequestMethod.GET)
	public @ResponseBody Integer getCountActuacionesInspeccion(@PathVariable Integer idInspeccion) {
		Actuaciones actuaciones = new Actuaciones();
		actuaciones.setInspeccion(new Inspecciones(idInspeccion));
		List<Actuaciones> resultado = this.actuacionesService.findAllLike(actuaciones, null, false);

		if (resultado != null) {
			return resultado.size();
		} else {
			return 0;
		}
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterActuaciones
	 *            Actuaciones Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param searchActuaciones
	 *            Actuaciones Bean que contiene los parametros de busqueda a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<Actuaciones> Dto que contiene el resultado de la
	 *         busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<Actuaciones>> search(
			@RequestJsonBody(param = "filter") Actuaciones filterActuaciones,
			@RequestJsonBody(param = "search") Actuaciones searchActuaciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ActuacionesController.logger.info("[POST - search] : Buscar Actuacioness");
		return this.actuacionesService.search(filterActuaciones, searchActuaciones, tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterActuaciones
	 *            Actuaciones Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") Actuaciones filterActuaciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ActuacionesController.logger
				.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Actuacioness");
		this.actuacionesService.removeMultiple(filterActuaciones, tableRequestDto, false);
		ActuacionesController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los
	 * registros mediante visualizacion jerarquica.
	 * 
	 * @param filterActuaciones
	 *            Actuaciones Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Actuaciones>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Actuaciones>> jerarquia(
			@RequestJsonBody(param = "filter") Actuaciones filterActuaciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ActuacionesController.logger.info("[POST - jerarquia] : Obtener Actuacioness jerarquia");
		return this.actuacionesService.jerarquia(filterActuaciones, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterActuaciones
	 *            Actuaciones Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Actuaciones>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Actuaciones>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") Actuaciones filterActuaciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ActuacionesController.logger.info("[POST - jerarquia] : Obtener Actuacioness jerarquia - Hijos");
		return this.actuacionesService.jerarquiaChildren(filterActuaciones, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */

	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<Actuaciones> getClipboardReport(
			@RequestJsonBody(param = "filter") Actuaciones filterActuaciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ActuacionesController.logger.info("[POST - clipboardReport] : : Copiar multiples usuarios");
		return this.actuacionesService.getMultiple(filterActuaciones, tableRequestDto, false);
	}

	@RequestMapping(value = "/obtenerDocumentosExpediente/{folderId}/{procedureId}/{idActuacion}", method = RequestMethod.GET)
	public @ResponseBody Integer obtenerDocumentosExpediente(@PathVariable String folderId,
			@PathVariable String procedureId, @PathVariable Integer idActuacion) {

		List<DocumentoExpediente> listaDocumentosExpediente = new ArrayList<DocumentoExpediente>();
		Integer documentosAportados = 0;

		try {
			listaDocumentosExpediente = this.ab61WebServiceAdaptador.obtenerDocumentosExpediente(folderId, procedureId,
					1);

			DocumentosSubidos filterDocumentosSubidos = new DocumentosSubidos();
			filterDocumentosSubidos.setIdActuacion(idActuacion);
			filterDocumentosSubidos.setAportadoExpediente(Constantes.APORTADO_EXPEDIENTE_SI);

			List<DocumentosSubidos> documentosSubidos = this.documentosSubidosService
					.findAllLike(filterDocumentosSubidos, null, false);

			for (DocumentoExpediente documentoExpediente : listaDocumentosExpediente) {
				for (DocumentosSubidos documentoSubido : documentosSubidos) {
					if (documentoSubido.getOidDokusi().equals(documentoExpediente.getOidDokusi())) {
						documentosAportados++;
					}
				}
			}

		} catch (Exception e) {
			ActuacionesController.logger.error("obtenerDocumentosExpediente - ERROR", e);
		}
		return documentosAportados;

	}

	@RequestMapping(value = "aportarActuaciones/{folderId}/{procedureId}", method = RequestMethod.POST)
	public @ResponseBody Integer aportarDocumento(HttpServletRequest httpRequest,
			@RequestBody List<Actuaciones> listaActuaciones, @PathVariable String folderId,
			@PathVariable String procedureId, @ModelAttribute("usuario") Usuario usuario) throws Ab61Exception {

		List<DocumentoWS> documentosWS = new ArrayList<DocumentoWS>();
		for (Actuaciones actuacion : listaActuaciones) {
			DocumentosSubidos filtroDocumentosSubido = new DocumentosSubidos();
			filtroDocumentosSubido.setIdActuacion(actuacion.getIdActuacion());
			filtroDocumentosSubido.setAportadoExpediente(Constantes.APORTADO_EXPEDIENTE_NO);

			List<DocumentosSubidos> documentosSubidosActuacion = this.documentosSubidosService
					.findAllLike(filtroDocumentosSubido, null, false);

			for (DocumentosSubidos documentoSubido : documentosSubidosActuacion) {
				DocumentoWS documentoWS = new DocumentoWS();
				documentoWS.setOidPid(documentoSubido.getOidPid());
				documentoWS.setIdPlantilla(documentoSubido.getPlantilla().getIdPlantilla());
				documentosWS.add(documentoWS);
			}

		}

		String resultado = this.documentosSubidosService.aportarDocumentoActuaciones(documentosWS, folderId,
				procedureId, usuario);

		if ("ok".equals(resultado)) {
			return documentosWS.size();
		} else {
			return -1;
		}

	}

}
